﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace XpathAppHelper
{
    public partial class XPath_Helper_Form : Form
    {
        //! Все переменные используемые в форме писать до инициализации формы. 
        //! Желательно задавать значения по умолчанию
        internal string pathSave;

        protected string nameDevice = string.Empty;

        //! Все переменные задавать до этого блока.
        //!  Здесь комментарий не нужен
        public XPath_Helper_Form()
        {
            InitializeComponent();
        }//! После этого блока идут действия по обработке событий
         //! Комментарии с /// обязательны. 
        //! Кроме методов обработки событий, никаких других методов в этом файле не должно быть

        /// <summary>
        /// Свернуть дерево элементов
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_Collapse_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            treeView_Full.CollapseAll();
        }

        /// <summary>
        /// Подключение к устройству.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_Connect_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события

            string mode = comboBox_ConnectMode.Text.ToLower();

            nameDevice = comboBox_Devices.SelectedItem.ToString().Trim();

            if (string.IsNullOrEmpty(nameDevice) || nameDevice.Contains("устройств"))
            {
                string message = "Выберите устройство из списка. Если список пустой, проверьте видимость через команду adb devices и перезапустите проект";
                System.Windows.Forms.MessageBox.Show(message, "Выберите устройство!",// Заголовок
                                              System.Windows.Forms.MessageBoxButtons.OK,
                                              System.Windows.Forms.MessageBoxIcon.Error,
                                              System.Windows.Forms.MessageBoxDefaultButton.Button1,
                                              System.Windows.Forms.MessageBoxOptions.DefaultDesktopOnly);

                return;
            }

            nameDevice = nameDevice.Split(' ')[0];

            label_SaveInfo.Text = "Click the Save button";

            button_Save.Enabled = true;

        }

        /// <summary>
        /// Формируем xpath по выбранным параметрам
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_CreateXpath_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Развернуть дерево элементов
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_Expand_Click(object sender, EventArgs e)
        {
            // Действия по выполнению этого события
            treeView_Full.ExpandAll();
        }

        /// <summary>
        /// Выбор папки с файлами.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_ResultDir_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            System.Windows.Forms.FolderBrowserDialog fbd = new FolderBrowserDialog();

            if (string.IsNullOrEmpty(pathSave))
            {
                // Открываем в последней выбранной папке
                fbd.SelectedPath = label_ResultDir.Text;
            }
            else
            {
                // Открываем в последней выбранной папке
                fbd.SelectedPath = pathSave;
            }

            if (fbd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                pathSave = fbd.SelectedPath;// + "\\"; ;
            }

            label_ResultDir.Text = pathSave;
        }

        /// <summary>
        /// Сохранение файла
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_Save_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события

            string mode = comboBox_ConnectMode.Text.ToLower();

            string info = string.Empty;

            string status = label_ConnectStatus.Text;

            string fileName = string.Empty;

            if (checkBox_FileName.Checked == true)
            {
                fileName = textBox_FileName.Text;
            }
        }

        /// <summary>
        /// Кнопка поиска и создания xpath пути выделенного элемента
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_Search_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            string textSearch = textBox_Search.Text;
    
            string paramSearch = comboBox_Search.SelectedItem.ToString();

        }

        /// <summary>
        /// Использовать имя файла вместо автоматического дата и режим.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void checkBox_FileName_CheckedChanged(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Для webview
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void checkBox_WebView_CheckedChanged(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Изменение выбора подключения
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void comboBox_ConnectMode_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Параметры поиска
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void comboBox_Search_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Копирование выделенной ячейки
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView_Attributes_CellContentClick(object sender, System.Windows.Forms.DataGridViewCellEventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Для копирования текста из ячейки
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dataGridView_XPath_CellContentClick(object sender, System.Windows.Forms.DataGridViewCellEventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Клик по картинке. Загрузка дерева элементов и атрибутов.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listView_Files_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события

            tabControl_Left.SelectedTab = tabPage_File;

            if (listView_Files.SelectedIndices.Count == 0)
            {
                return;
            }

            string nameSelectedFile = string.Empty;

            // Определяем выделеный элемент картинки
            if (listView_Files.FocusedItem != null)
            {
                nameSelectedFile = listView_Files.FocusedItem.Text;
            }

        }

        /// <summary>
        /// Поле ввода текста для поиска
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox_Search_TextChanged(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            if (!button_Search.Enabled)
            {
                button_Search.Enabled = true;
            }
        }

        /// <summary>
        /// Выбор узла в дереве элементов
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void treeView_Full_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
        {
            // Действия по выполнению этого события
            string curNode = treeView_Full.SelectedNode.Text;

            string bounds = curNode.Split(' ').Last();// [871,1769][1073,1977]
        }

        /// <summary>
        /// При загрузке формы
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void XPath_Helper_Form_Load(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            label_ConnectStatus.Text = "No Devices";
            label_SaveInfo.Text = "Click the Connect button";

            comboBox_ConnectMode.Text = "ADB";

            if (comboBox_ConnectMode.Text.ToLower() == "adb")
            {
                checkBox_WebView.Enabled = false;
            }

            button_Save.Enabled = false;

            string workDir = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);

            string path = System.IO.Path.Combine(workDir, "XPathHelper", "SaveScreens");

            if (!Directory.Exists(path))
            {
                Directory.CreateDirectory(path);
            }

            label_ResultDir.Text = path;

            pathSave = label_ResultDir.Text;

            string[] adbDevices = null;

            try
            {
                adbDevices = new string[] { "Выберите устройство" };
            }
            catch (Exception ex)
            {
                tabControl_Selected.SelectedTab = tabPage_XmlCode;

                richTextBox_XmlNode.SelectionColor = System.Drawing.Color.Red;
                richTextBox_XmlNode.SelectionFont = new System.Drawing.Font("Arial", 12, System.Drawing.FontStyle.Regular);
                richTextBox_XmlNode.AppendText("Проверьте настройку окружения и PATH" + Environment.NewLine);
                richTextBox_XmlNode.AppendText(ex.Message + Environment.NewLine + ex.StackTrace + Environment.NewLine);

                string message = ex.Message;
                System.Windows.Forms.MessageBox.Show(message, "Ошибка! ",// Заголовок
                                              System.Windows.Forms.MessageBoxButtons.OK,
                                              System.Windows.Forms.MessageBoxIcon.Error,
                                              System.Windows.Forms.MessageBoxDefaultButton.Button1,
                                              System.Windows.Forms.MessageBoxOptions.DefaultDesktopOnly);

                return;
            }

            comboBox_Devices.Items.AddRange(adbDevices);

            if (adbDevices != null && adbDevices.Length == 1)
            {
                comboBox_Devices.SelectedIndex = 0;

                tabControl_Selected.SelectedTab = tabPage_XmlCode;

                richTextBox_XmlNode.SelectionColor = System.Drawing.Color.Red;
                richTextBox_XmlNode.SelectionFont = new System.Drawing.Font("Arial", 14, System.Drawing.FontStyle.Bold);
                richTextBox_XmlNode.AppendText("Выберите устройство");
            }
            else
            {
                richTextBox_XmlNode.Clear();

                comboBox_Devices.Items.Add("Выберите устройство");
                comboBox_Devices.SelectedItem = "Выберите устройство";
            }

            if (checkBox_FileName.Checked == true)
            {// Меняем видимость поля ввода xpath для xml
                textBox_FileName.Enabled = true;
                textBox_FileName.Text = string.Empty;
            }
            else
            {
                textBox_FileName.Enabled = false;
                textBox_FileName.Text = "Input Name Screen";
            }

            comboBox_Search.Items.AddRange(new string[] { "xpath", "all", "index", "text", "resource-id", "class", "package", "content-desc", "checkable", "checked", "clickable", "enabled", "focusable", "focused", "scrollable", "long-clickable", "password", "selected", "bounds" });

            comboBox_Search.SelectedItem = "all";

            button_Search.Enabled = false;

            label_Selected.Text = "0";
        }

        /// <summary>
        /// Ссылка на телеграм канал
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void linkLabel_TGChannel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
        {
            // Действия по выполнению этого события
            System.Diagnostics.Process.Start("https://t.me/radv_softnews");
        }

        /// <summary>
        /// Ссылка на тему ZennolAb
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void linkLabel_Forum_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
        {
            // Действия по выполнению этого события

            // откроет данную ссылку в браузере по умолчанию.
            System.Diagnostics.Process.Start("https://zennolab.com/discussion/threads/plugin-upravlenie-realnymi-android-ustrojstvami.89446/");
        }

        /// <summary>
        /// Копирование xpath в буфер
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_CopyXPath_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Очистка поля поиска
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void label_Selected_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            textBox_Search.Clear();
            label_Selected.Text = "0";
        }

        /// <summary>
        /// Добавление /parent::
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_Parent_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            if (comboBox_Search.Text != "xpath")
            {
                comboBox_Search.Text = "xpath";
            }
        }

        /// <summary>
        /// Добавление /following::
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_Following_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            if (comboBox_Search.Text != "xpath")
            {
                comboBox_Search.Text = "xpath";
            }
        }

        /// <summary>
        /// Добавление /preceding::
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_Preceding_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            if (comboBox_Search.Text != "xpath")
            {
                comboBox_Search.Text = "xpath";
            }

        }

        /// <summary>
        /// Добавление /preceding-sibling::
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_PSibling_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            if (comboBox_Search.Text != "xpath")
            {
                comboBox_Search.Text = "xpath";
            }
        }

        /// <summary>
        /// Добавление /following-sibling::
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_FSibling_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            if (comboBox_Search.Text != "xpath")
            {
                comboBox_Search.Text = "xpath";
            }
        }

        /// <summary>
        /// Добавление в поле поиска
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_CopyToSearch_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
            if (comboBox_Search.Text != "xpath")
            {
                comboBox_Search.Text = "xpath";// Очищает поле ввода.
            }
        }

        /// <summary>
        /// Клик по картинке
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox_Screen_Click(object sender, System.EventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Закрытие формы. Остановка процессов
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void XPath_Helper_Form_FormClosing(object sender, System.Windows.Forms.FormClosingEventArgs e)
        {
            // Действия по выполнению этого события
        }

        /// <summary>
        /// Изменение выбора в списке
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void comboBox_Devices_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Действия по выполнению этого события
            // Действия по выполнению этого события
            if (comboBox_Search.Text != "xpath")
            {
                comboBox_Search.Text = "xpath";
            }
        }
    }

}