﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
//Идея взята из этой темы https://zennolab.com/discussion/threads/sozdanie-i-rabota-s-sobstvennymi-formami-oknami-windows-cherez-snippety-c.13416/
namespace ZennoWinForms
{
    public class ZennoForm
    {
        /// <summary>
        /// Сама форма для зенно
        /// </summary>
        public System.Windows.Forms.Form zForm;

        /// <summary>
        /// Конструктор создания формы
        /// </summary>
        public ZennoForm()
        {// Конструктор
            zForm = new System.Windows.Forms.Form();
        }

        /// <summary>
        /// Конструктор с параметрами
        /// </summary>
        /// <param name="nameForm"></param>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="width"></param>
        /// <param name="heigth"></param>
        public ZennoForm(string nameForm, int x = 100, int y = 100, int width = 300, int heigth = 300)
        {
            zForm = new System.Windows.Forms.Form();
            zForm.Text = nameForm;
            zForm.Top = x;
            zForm.Left = y;

            zForm.Width = width;    //- задает ширину формы в пикселях
            zForm.Height = heigth;    //- задает высоту формы в пикселях
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        public class ParamLocationControl
        {
            /// <summary>
            /// Номер столбца
            /// </summary>
            public int IndexCol { get; set; }

            /// <summary>
            /// Номер строки
            /// </summary>
            public int IndexRow { get; set; }

            /// <summary>
            /// Контрол
            /// </summary>
            public System.Windows.Forms.Control ItemControl { get; set; }
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        public class ParamRow
        {
            /// <summary>
            /// Высота строки. Например: 30F
            /// </summary>
            public float RowHeight { get; set; }

            /// <summary>
            /// Тип значения System.Windows.Forms.SizeType
            /// </summary>
            public System.Windows.Forms.SizeType RowSizeType { get; set; }
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        public class ParamTableLayoutPanel
        {
            /// <summary>
            /// Количество столбцов
            /// </summary>
            public int ColCount { get; set; }

            /// <summary>
            /// Параметры Контрола для добавления
            /// </summary>
            public ParamLocationControl[] ParamControl { get; set; }

            /// <summary>
            /// Количество строк
            /// </summary>
            public int RowCount { get; set; }
            
            /// <summary>
            /// Параметры стиля строки
            /// </summary>
            public ParamRow[] RowParam { get; set; }

            ///// <summary>
            ///// Тип значения System.Windows.Forms.SizeType
            ///// </summary>
            //public System.Windows.Forms.SizeType[] RowSizeType { get; set; }

            ///// <summary>
            ///// Высота строки. Например: 30F
            ///// </summary>
            //public float[] RowHeight { get; set; }
        }

        /// <summary>
        /// Создаем кнопку с параметрами
        /// </summary>
        /// <param name="text"></param>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="width"></param>
        /// <param name="heigth"></param>
        /// <returns></returns>
        public System.Windows.Forms.Button AddButton(string text, int x, int y, int width, int heigth)
        {
            //создаем кнопку
            System.Windows.Forms.Button button = new System.Windows.Forms.Button
            {
                //задаем имя чекбоксам
                Text = text,
                //положение в окне
                Location = new System.Drawing.Point(x, y),
                //размер кнопочки
                Size = new System.Drawing.Size(width, heigth)
            };
            //кидаем на форму
            zForm.Controls.Add(button);

            return button;
        }

        /// <summary>
        /// Добавляем кнопку без параметров
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.Button AddButton()
        {
            System.Windows.Forms.Button button = new System.Windows.Forms.Button();

            //кидаем на форму
            zForm.Controls.Add(button);

            return button;
        }

        /// <summary>
        /// Добавляем поле чекбокса с параметрами
        /// </summary>
        /// <param name="text"></param>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="checkstatus"></param>
        /// <param name="width"></param>
        /// <param name="heigth"></param>
        /// <returns></returns>
        public System.Windows.Forms.CheckBox AddCheckBox(string text, int x, int y, bool checkstatus, int width, int heigth)
        {
            //создаем чекбокс
            System.Windows.Forms.CheckBox chbox1 = new System.Windows.Forms.CheckBox
            {
                //задаем имя чекбоксу
                Text = text,
                //его положение в окне
                Location = new System.Drawing.Point(x, y),

                Checked = checkstatus
            };

            //добавляем на форму
            zForm.Controls.Add(chbox1);

            return chbox1;
        }

        /// <summary>
        /// Добавляем чекбокс без параметров
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.CheckBox AddCheckBox()
        {
            System.Windows.Forms.CheckBox checkBox = new System.Windows.Forms.CheckBox();

            //кидаем на форму
            zForm.Controls.Add(checkBox);

            return checkBox;
        }

        /// <summary>
        /// Добавляем выпадающий список с параметрами
        /// </summary>
        /// <param name="values"></param>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="width"></param>
        /// <param name="heigth"></param>
        /// <returns></returns>
        public System.Windows.Forms.ComboBox AddComboBox(string[] values, int x, int y, int width, int heigth)
        {
            //создаем выпадающий список
            System.Windows.Forms.ComboBox combobox = new System.Windows.Forms.ComboBox();

            //указываем, какие в нем должны быть значения
            // combobox.Items.AddRange(new object[] { "котик1", "котик2", "котик3" });
            combobox.Items.AddRange(values);

            //Говорим куда хотим его поставить
            combobox.Location = new System.Drawing.Point(x, y);
            //указываем его ширину, если нужно
            combobox.Width = width;
            //крепим его на форму
            zForm.Controls.Add(combobox);

            return combobox;
        }

        /// <summary>
        /// Добавляем выпадающий без параметров
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.ComboBox AddComboBox()
        {
            System.Windows.Forms.ComboBox comboBox = new System.Windows.Forms.ComboBox();
            //кидаем на форму
            zForm.Controls.Add(comboBox);

            return comboBox;
        }

        /// <summary>
        /// Добавляем элемент DataGridView
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.DataGridView AddDataGridView()
        {
            System.Windows.Forms.DataGridView dataGridView = new System.Windows.Forms.DataGridView();

            //кидаем на форму
            zForm.Controls.Add(dataGridView);

            return dataGridView;
        }

        /// <summary>
        /// Добавляем элемент DataGridViewComboBoxColumn
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.DataGridViewComboBoxColumn AddDataGridViewComboBoxColumn()
        {
            System.Windows.Forms.DataGridViewComboBoxColumn gridViewComboBoxColumn = new System.Windows.Forms.DataGridViewComboBoxColumn();

            return gridViewComboBoxColumn;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.DataGridViewTextBoxColumn AddDataGridViewTextBoxColumn()
        {
            System.Windows.Forms.DataGridViewTextBoxColumn dataGridViewTextBoxColumn = new System.Windows.Forms.DataGridViewTextBoxColumn();

            return dataGridViewTextBoxColumn;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.Label AddLabel()
        {
            System.Windows.Forms.Label label = new System.Windows.Forms.Label();

            //кидаем на форму
            zForm.Controls.Add(label);

            return label;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.LinkLabel AddLinkLabel()
        {
            System.Windows.Forms.LinkLabel linkLabel = new System.Windows.Forms.LinkLabel();

            //кидаем на форму
            zForm.Controls.Add(linkLabel);

            return linkLabel;
        }

        /// <summary>
        /// Добавляем элемент со списком
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="width"></param>
        /// <param name="heigth"></param>
        /// <returns></returns>
        public System.Windows.Forms.ListBox AddListBox(int x, int y, int width, int heigth)
        {
            //создаем листбокс
            System.Windows.Forms.ListBox listb = new System.Windows.Forms.ListBox
            {

                //Указываем положение на форме
                Location = new System.Drawing.Point(x, y),

                //указываем его размеры
                Width = width,
                Height = heigth
            };

            //кидаем на форму
            zForm.Controls.Add(listb);

            return listb;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.ListView AddListView()
        {
            System.Windows.Forms.ListView listView = new System.Windows.Forms.ListView();

            //кидаем на форму
            zForm.Controls.Add(listView);

            return listView;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.PictureBox AddPictureBox()
        {
            System.Windows.Forms.PictureBox pictureBox = new System.Windows.Forms.PictureBox();

            //кидаем на форму
            zForm.Controls.Add(pictureBox);

            return pictureBox;
        }

        /// <summary>
        /// Добавляем поле с радио
        /// </summary>
        /// <param name="text"></param>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="checkstatus"></param>
        /// <param name="width"></param>
        /// <param name="heigth"></param>
        /// <returns></returns>
        public System.Windows.Forms.RadioButton AddRadioButton(string text, int x, int y, bool checkstatus, int width, int heigth)
        {
            //создаем первый радиобаттон
            System.Windows.Forms.RadioButton rb1 = new System.Windows.Forms.RadioButton
            {
                //присваиваем значение
                Text = text,
                //говорим куда поставить
                Location = new System.Drawing.Point(x, y),

                Width = width,
                Height = heigth,

                Checked = checkstatus
            };

            //добавляем rb1 на форму
            zForm.Controls.Add(rb1);

            return rb1;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.RadioButton AddRadioButton()
        {
            //создаем первый радиобаттон
            System.Windows.Forms.RadioButton rb1 = new System.Windows.Forms.RadioButton();

            //добавляем rb1 на форму
            zForm.Controls.Add(rb1);

            return rb1;
        }

        /// <summary>
        /// Добавляем поле форматированного текста с параметрами
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="width"></param>
        /// <param name="heigth"></param>
        /// <returns></returns>
        public System.Windows.Forms.RichTextBox AddRichTextBox(int x, int y, int width, int heigth)
        {
            //создаем richтекстбокс
            System.Windows.Forms.RichTextBox rtbox = new System.Windows.Forms.RichTextBox
            {
                //указываем местоположение
                Location = new System.Drawing.Point(x, y),
                //указываем размеры в пикселях
                Width = width,
                Height = heigth
            };
            //крепим на форму
            zForm.Controls.Add(rtbox);

            return rtbox;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.RichTextBox AddRichTextBox()
        {
            //создаем richтекстбокс
            System.Windows.Forms.RichTextBox rtbox = new System.Windows.Forms.RichTextBox();

            //крепим на форму
            zForm.Controls.Add(rtbox);

            return rtbox;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="itemToPanel1"></param>
        /// <param name="itemToPanel2"></param>
        /// <returns></returns>
        public System.Windows.Forms.SplitContainer AddSplitContainer(System.Windows.Forms.Control itemToPanel1, System.Windows.Forms.Control itemToPanel2)
        {
            System.Windows.Forms.SplitContainer splitContainer = new System.Windows.Forms.SplitContainer();

            splitContainer.Panel1.Controls.Add(itemToPanel1);

            splitContainer.Panel2.Controls.Add(itemToPanel2);

            //кидаем на форму
            zForm.Controls.Add(splitContainer);

            return splitContainer;
        }

        //! ==================================
        /// <summary>
        /// Добавляем элемент SplitContainer 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.SplitContainer AddSplitContainer()
        {
            System.Windows.Forms.SplitContainer elControl = new System.Windows.Forms.SplitContainer();

            zForm.Controls.Add(elControl);

            return elControl;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="tabs"></param>
        /// <returns></returns>
        public System.Windows.Forms.TabControl AddTabControl(System.Windows.Forms.TabPage[] tabs)
        {
            System.Windows.Forms.TabControl tabControl = new System.Windows.Forms.TabControl();

            for (int t = 0; t < tabs.Length; t++)
            {
                tabControl.Controls.Add(tabs[t]);
            }

            //кидаем на форму
            zForm.Controls.Add(tabControl);

            return tabControl;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="itemToPanel1"></param>
        /// <param name="itemToPanel2"></param>
        /// <returns></returns>
        public System.Windows.Forms.TabControl AddTabControl(System.Windows.Forms.Control itemToPanel1, System.Windows.Forms.Control itemToPanel2)
        {
            System.Windows.Forms.TabControl tabControl = new System.Windows.Forms.TabControl();

            return tabControl;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.TabControl AddTabControl()
        {
            System.Windows.Forms.TabControl elControl = new System.Windows.Forms.TabControl();
            zForm.Controls.Add(elControl);
            return elControl;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="paramPanel"></param>
        /// <returns></returns>
        public System.Windows.Forms.TableLayoutPanel AddTableLayoutPanel(ParamTableLayoutPanel paramPanel)//int colCount, int rowCount, System.Windows.Forms.Control[] itemsToPanel)
        {//! Для сложных вложенных объектов
            // Количество Столбцов, параметры строк, массив контролов
            System.Windows.Forms.TableLayoutPanel tableLayoutPanel = new System.Windows.Forms.TableLayoutPanel();

            int colCount = paramPanel.ColCount;

            for (int t = 0; t < colCount; t++)
            {
                // контрол, столбец, строка
                tableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
            }

            ParamLocationControl[] paramLocation = paramPanel.ParamControl;

            for (int t = 0; t < paramLocation.Length; t++)
            {
                // контрол, столбец, строка
                tableLayoutPanel.Controls.Add(paramLocation[t].ItemControl, paramLocation[t].IndexCol, paramLocation[t].IndexRow);
            }

            int rowCount = paramPanel.RowParam.Length;

            tableLayoutPanel.RowCount = rowCount;

            for (int t = 0; t < rowCount; t++)
            {
                // Тип значения
                System.Windows.Forms.SizeType sizeType = paramPanel.RowParam[t].RowSizeType;// System.Windows.Forms.SizeType.Absolute;
                float height = paramPanel.RowParam[t].RowHeight;

                //Настройка стиля строки. Тип значения, высота строки
                tableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(sizeType, height));
            }

            //кидаем на форму
            zForm.Controls.Add(tableLayoutPanel);

            return tableLayoutPanel;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.TableLayoutPanel AddTableLayoutPanel()
        {
            System.Windows.Forms.TableLayoutPanel elControl = new System.Windows.Forms.TableLayoutPanel();
            zForm.Controls.Add(elControl);
            return elControl;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.TabPage AddTabPage()
        {
            System.Windows.Forms.TabPage tabPage = new System.Windows.Forms.TabPage();

            return tabPage;
        }


        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="itemsToPage"></param>
        /// <returns></returns>
        public System.Windows.Forms.TabPage AddTabPage(System.Windows.Forms.Control[] itemsToPage)
        {
            System.Windows.Forms.TabPage tabPage = new System.Windows.Forms.TabPage();

            for (int t = 0; t < itemsToPage.Length; t++)
            {
                tabPage.Controls.Add(itemsToPage[t]);
            }

            return tabPage;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="tableLayoutPanel"></param>
        /// <returns></returns>
        public System.Windows.Forms.TabPage AddTabPage(ref TableLayoutPanel tableLayoutPanel)
        {
            System.Windows.Forms.TabPage elControl = new System.Windows.Forms.TabPage();

            elControl.Controls.Add(tableLayoutPanel);

            return elControl;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="control"></param>
        /// <returns></returns>
        public System.Windows.Forms.TabPage AddTabPage(ref System.Windows.Forms.RichTextBox control)
        {
            System.Windows.Forms.TabPage elControl = new System.Windows.Forms.TabPage();

            elControl.Controls.Add(control);

            return elControl;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="control"></param>
        /// <returns></returns>
        public System.Windows.Forms.TabPage AddTabPage(ref System.Windows.Forms.DataGridView control)
        {
            System.Windows.Forms.TabPage elControl = new System.Windows.Forms.TabPage();

            elControl.Controls.Add(control);

            return elControl;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <param name="control"></param>
        /// <returns></returns>
        public System.Windows.Forms.TabPage AddTabPage(ref System.Windows.Forms.Control control)
        {
            System.Windows.Forms.TabPage elControl = new System.Windows.Forms.TabPage();

            elControl.Controls.Add(control);

            return elControl;
        }

        /// <summary>
        /// Добавляем текстовое поле с параметрами
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="width"></param>
        /// <param name="heigth"></param>
        /// <returns></returns>
        public System.Windows.Forms.TextBox AddTextBox(int x, int y, int width, int heigth)
        {
            //создаем текстбокс
            System.Windows.Forms.TextBox textb = new System.Windows.Forms.TextBox
            {
                //указываем местоположение
                Location = new System.Drawing.Point(x, y),
                //так же можно указать размеры текстбокса
                Width = width
            };
            // добавляем его на форму
            zForm.Controls.Add(textb);

            return textb;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.TextBox AddTextBox()
        {
            System.Windows.Forms.TextBox textBox = new System.Windows.Forms.TextBox();

            //кидаем на форму
            zForm.Controls.Add(textBox);

            return textBox;
        }

        /// <summary>
        /// Добавляем элемент 
        /// </summary>
        /// <returns></returns>
        public System.Windows.Forms.TreeView AddTreeView()
        {
            System.Windows.Forms.TreeView treeView = new System.Windows.Forms.TreeView();

            //кидаем на форму
            zForm.Controls.Add(treeView);

            return treeView;
        }

        /// <summary>
        /// Закрываем форму и освобождаем ресурсы
        /// </summary>
        public void Close()
        {
            try
            {
                zForm.Close();
                zForm.Dispose();
            }
            catch
            {

            }
        }

        /// <summary>
        /// Освобождаем ресурсы
        /// </summary>
        public void Dispose()
        {
            try
            {
                zForm.Dispose();
            }
            catch
            {

            }
        }

        /// <summary>
        /// Показываем форму
        /// </summary>
        public void ShowForm()
        {
            zForm.Focus();
            zForm.WindowState = FormWindowState.Normal;
            zForm.ShowDialog();
        }
    }

}
